#!/bin/bash

# fix for broken `systemctl --user`
export XDG_RUNTIME_DIR="/run/user/$UID"
export DBUS_SESSION_BUS_ADDRESS="unix:path=${XDG_RUNTIME_DIR}/bus"

echo Stopping...
systemctl --user stop m3.service

echo Updating...
rm -rf ~/server/
mkdir ~/server/
cp -R * ~/server/
cd ~/server/
pipenv --python 3.8 --site-packages
pipenv install

echo Starting...
systemctl --user start m3.service
echo Done.
